﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.IO;

namespace CloudServer
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //发送到WP设备的消息
            string msg = String.Format("{0}{1}, {2}度", LocationComboBox.Text,
                    WeatherComboBox.Text, TemperatureTextBox.Text);

            string type = NotificationTypeComboBox.Text as string;
            if (type == "Raw")
            {
                byte[] strBytes = new UTF8Encoding().GetBytes(msg);
                SendRawNotification(strBytes);
            }
            else if (type == "Toast")
            {
                string toastMessage = "<?xml version=\"1.0\" encoding=\"utf-8\"?>" +
                        "<wp:Notification xmlns:wp=\"WPNotification\">" +
                           "<wp:Toast>" +
                              "<wp:Text1>天气更新</wp:Text1>" +
                              "<wp:Text2>" + msg + "</wp:Text2>" +
                           "</wp:Toast>" +
                        "</wp:Notification>";
                byte[] strBytes = new UTF8Encoding().GetBytes(toastMessage);
                SendToastNotification(strBytes);
            }
            else if (type == "Tile")
            {
                string tileMessage = "<?xml version=\"1.0\" encoding=\"utf-8\"?>" +
                    "<wp:Notification xmlns:wp=\"WPNotification\">" +
                       "<wp:Tile>" +
                          "<wp:BackgroundImage>/Images/" + WeatherComboBox.Text + ".png</wp:BackgroundImage>" +
                          "<wp:Count>" + TemperatureTextBox.Text + "</wp:Count>" +
                          "<wp:Title>" + LocationComboBox.Text + "</wp:Title>" +
                       "</wp:Tile> " +
                    "</wp:Notification>";
                byte[] strBytes = new UTF8Encoding().GetBytes(tileMessage);
                SendTileNotification(strBytes);
            }
        }

        private void SendTileNotification(byte[] Payload)
        {
            // The URI that the Push Notification Service returns to the Push Client when creating a notification channel.
            HttpWebRequest sendNotificationRequest = (HttpWebRequest)WebRequest.Create(NotificationUriTextBox.Text);

            // HTTP POST is the only allowed method to send the notification.
            sendNotificationRequest.Method = WebRequestMethods.Http.Post;

            // The optional custom header X-MessageID uniquely identifies a notification message. If it is present, the 
            // same value is returned in the notification response. It must be a string that contains a UUID.
            sendNotificationRequest.Headers["X-MessageID"] = Guid.NewGuid().ToString();

            // Sets toast notification
            sendNotificationRequest.ContentType = "text/xml; charset=utf-8";
            sendNotificationRequest.Headers.Add("X-WindowsPhone-Target", "token");
            sendNotificationRequest.Headers.Add("X-NotificationClass", "1");
            // Possible batching interval values:
            // 1: The message is delivered by the Push Notification Service immediately.
            // 11: The message is delivered by the Push Notification Service within 450 seconds.
            // 21: The message is delivered by the Push Notification Service within 900 seconds.

            // Sets the web request content length.
            sendNotificationRequest.ContentLength = Payload.Length;

            // Sets the notification payload to send.
            byte[] notificationMessage = Payload;

            // Sends the notification.
            //如果是在Silverlight程序中应使用异步方法替换GetRequestStream()
            using (Stream requestStream = sendNotificationRequest.GetRequestStream())
            {
                requestStream.Write(notificationMessage, 0, notificationMessage.Length);
            }

            // Gets the response.
            HttpWebResponse response = (HttpWebResponse)sendNotificationRequest.GetResponse();
            string notificationStatus = response.Headers["X-NotificationStatus"];
            string notificationChannelStatus = response.Headers["X-SubscriptionStatus"];
            string deviceConnectionStatus = response.Headers["X-DeviceConnectionStatus"];
            MsgLabel.Text = String.Format("通知状态：{0}，管道状态：{1}，设备状态：{2}",
                notificationStatus, notificationChannelStatus, deviceConnectionStatus);
        }

        private void SendToastNotification(byte[] Payload)
        {
            // The URI that the Push Notification Service returns to the Push Client when creating a notification channel.
            HttpWebRequest sendNotificationRequest = (HttpWebRequest)WebRequest.Create(NotificationUriTextBox.Text);

            // HTTP POST is the only allowed method to send the notification.
            sendNotificationRequest.Method = WebRequestMethods.Http.Post;

            // The optional custom header X-MessageID uniquely identifies a notification message. If it is present, the 
            // same value is returned in the notification response. It must be a string that contains a UUID.
            sendNotificationRequest.Headers["X-MessageID"] = Guid.NewGuid().ToString();

            // Sets toast notification
            sendNotificationRequest.ContentType = "text/xml; charset=utf-8";
            sendNotificationRequest.Headers.Add("X-WindowsPhone-Target", "toast");
            sendNotificationRequest.Headers.Add("X-NotificationClass", "2");
            // Possible batching interval values:
            // 2: The message is delivered by the Push Notification Service immediately.
            // 12: The message is delivered by the Push Notification Service within 450 seconds.
            // 22: The message is delivered by the Push Notification Service within 900 seconds.

            // Sets the web request content length.
            sendNotificationRequest.ContentLength = Payload.Length;

            // Sets the notification payload to send.
            byte[] notificationMessage = Payload;

            // Sends the notification.
            //如果是在Silverlight程序中应使用异步方法替换GetRequestStream()
            using (Stream requestStream = sendNotificationRequest.GetRequestStream())
            {
                requestStream.Write(notificationMessage, 0, notificationMessage.Length);
            }

            // Gets the response.
            HttpWebResponse response = (HttpWebResponse)sendNotificationRequest.GetResponse();
            string notificationStatus = response.Headers["X-NotificationStatus"];
            string notificationChannelStatus = response.Headers["X-SubscriptionStatus"];
            string deviceConnectionStatus = response.Headers["X-DeviceConnectionStatus"];
            MsgLabel.Text = String.Format("通知状态：{0}，管道状态：{1}，设备状态：{2}",
                notificationStatus, notificationChannelStatus, deviceConnectionStatus);
        }
        private void SendRawNotification(byte[] Payload)
        {
            // The URI that the Push Notification Service returns to the Push Client when creating a notification channel.
            HttpWebRequest sendNotificationRequest = (HttpWebRequest)WebRequest.Create(NotificationUriTextBox.Text);

            // HTTP POST is the only allowed method to send the notification.
            sendNotificationRequest.Method = WebRequestMethods.Http.Post;

            // The optional custom header X-MessageID uniquely identifies a notification message. If it is present, the 
            // same value is returned in the notification response. It must be a string that contains a UUID.
            sendNotificationRequest.Headers["X-MessageID"] = Guid.NewGuid().ToString();

            // Sets raw notification
            sendNotificationRequest.ContentType = "text/xml; charset=utf-8";
            sendNotificationRequest.Headers.Add("X-NotificationClass", "3");
            // Possible batching interval values:
            // 3: The message is delivered by the Push Notification Service immediately.
            // 13: The message is delivered by the Push Notification Service within 450 seconds.
            // 23: The message is delivered by the Push Notification Service within 900 seconds.

            // Sets the web request content length.
            sendNotificationRequest.ContentLength = Payload.Length;

            // Sets the notification payload to send.
            byte[] notificationMessage = Payload;

            // Sends the notification.
            //如果是在Silverlight程序中应使用异步方法替换GetRequestStream()
            using (Stream requestStream = sendNotificationRequest.GetRequestStream())
            {
                requestStream.Write(notificationMessage, 0, notificationMessage.Length);
            }

            // Gets the response.
            HttpWebResponse response = (HttpWebResponse)sendNotificationRequest.GetResponse();
            string notificationStatus = response.Headers["X-NotificationStatus"];
            string notificationChannelStatus = response.Headers["X-SubscriptionStatus"];
            string deviceConnectionStatus = response.Headers["X-DeviceConnectionStatus"];
            MsgLabel.Text = String.Format("通知状态：{0}，管道状态：{1}，设备状态：{2}",
                notificationStatus, notificationChannelStatus, deviceConnectionStatus);
        }
    }
}
